'=================================================
'=                                Rc Nitro-car ignition killer
'=                                  Evert dekker 2007
'=================================================
'=    Copyright for commercial use, for private use have fun
'=================================================
'=      Version 1.0 10/2/2007 -  Bascom version 1.11.8.3
'=================================================
'Fusebit setting; clock/8 off rest standaard

$regfile = "Attiny45.dat"
$crystal = 8000000
$eepleave
$hwstack = 40
$swstack = 16
$framesize = 16

'=== Dimension the variabele===
Dim Pulslengte As Word
Dim Voltagesetting As Eram Word At &H02
Dim Voltage As Word
Dim L As Byte

'===Setup the ports===
Config Portb.0 = Output                                     ' Relais uitgang
Config Portb.3 = Output                                     ' Status led
Config Pinb.1 = Input                                       ' Drukknop
Config Adc = Single , Prescaler = Auto , Reference = 6      'setup de a/d convertor met een interne referentie van 2.54V
Config Debounce = 30


'===Aliassen & constanten===
Relais Alias Portb.0
Statusled Alias Portb.3
Drukknop Alias Pinb.1

'===Set the port===
Set Pinb.1                                                  ' Activeer de pull-up weerstand voor de drukknop
Start Adc                                                   ' Start de a/d convertor
Set Statusled                                               'Satusled uitschakelen bij opstarten

'===Main===
Waitms 100
If Drukknop = 0 Then                                        'Drukknop is ingedrukt tijdens het opstarten
Voltagesetting = 660                                        ' Bewaar de gemeten waarde in eeprom
Gosub Knipperled                                            'Laat de led  2x knipperen ter bevestiging
Gosub Knipperled
End If
Bitwait Drukknop , Set                                      ' Wacht todat de drukknop weer is losgelaten


Do
Pulsein Pulslengte , Pinb , 4 , 1                           'Meet de binnenkomende servo puls. Experimenteel vastgesteld met een 8MHZ crystal, pulslengte's liggen tussen 97 en 170
If Pulslengte > 94 And Pulslengte < 114 Then
Set Relais
End If
If Pulslengte > 150 And Pulslengte < 170 Then
Reset Relais
End If
Gosub Meetvoltage
Debounce Drukknop , 0 , Knopingedrukt , Sub
Loop
End

'===Subroutines===
Knipperled:
Waitms 300
Reset Statusled
Waitms 150
Set Statusled
Waitms 150
Return

Knopingedrukt:
Voltage = Getadc(1)
Voltagesetting = Voltage
Gosub Knipperled
Return

Meetvoltage:
Voltage = Getadc(1)                                         ' Meet de battery spanning op adc kanaal 1
If Voltage < Voltagesetting Then                            'Als de spaniing lager is als de geprog spanning         rem  660 represents 4.2V , 702=4.5V, 775=5V
    For L = 1 To 10                                         'Nu meten we de spanning 10x met een interval van 15mSec om van false meetingen af te komen. (spike's etc..)
       Waitms 15
       Voltage = Getadc(1)
       If Voltage => Voltagesetting Then Return             ' Voltage is boven de geprog spanning, moet een spike zijn geweest terug naar hoofd programma
    Next L
Do                                                          ' Battery spanning is the laag, blijf in een eindeloose loop hangen
Debounce Drukknop , 0 , Knopingedrukt , Sub
Reset Relais
Toggle Statusled                                            ' Knipper de rode led om aan te geven  LOW BAT
Waitms 75
Loop
End If
Return